package es01;

public class Spiaggia {
	private final Cliente[][] ombrelloni;
	
	public Spiaggia (int nOmbrelloni, int nGiorni) {
		if (nOmbrelloni<1) nOmbrelloni=1;
		if (nGiorni<1) nGiorni=1;
		ombrelloni= new Cliente[nOmbrelloni][nGiorni];
	}
	
	public Cliente getPrenotazione (int ombrellone, int giorno) {
		if (ombrellone<0 || ombrellone>=ombrelloni.length) 
			throw new EccezioneOmbrellone("Numero ombrellone errato");
		if (giorno<0 || giorno>=ombrelloni[0].length) 
			throw new EccezioneGiorno("Numero giorno errato");
		return ombrelloni[ombrellone][giorno];
	}
	
	public int addPrenotazione (Cliente c, int giornoInizio,
			                    int giornoFine) {
		if (c==null) return -1;
		if (giornoInizio<0 || giornoInizio>=ombrelloni[0].length) 
			throw new EccezioneGiorno("Numero giorno inizio errato");
		if (giornoFine<0 || giornoFine>=ombrelloni[0].length) 
			throw new EccezioneGiorno("Numero giorno fine errato");
		if (giornoFine<giornoInizio) 
			throw new EccezioneGiorno("giornoInizio deve precedere giornoFine");
		for (int i=0; i<ombrelloni.length; i++) {
			boolean occupato=false;
			for (int j=giornoInizio; j<=giornoFine && !occupato; j++) {
				if (ombrelloni[i][j]!=null) 
					occupato=true;
			}
			if (!occupato) {
				//aggiorno l'array ombrelloni
				for (int j=giornoInizio; j<=giornoFine; j++) {
					ombrelloni[i][j]=c;
				}
				return i;
			}
				
		}
		return -1;
	}
}
