package es03;

/*
 * soluzione che usa un array pi lungo del numero di elementi
 * effettivamente presenti nel multinsieme
 */

public class Multinsieme {
	private int[] a;
	private int numElementi;
	
	public Multinsieme (int n) {
		a = new int[n];
		numElementi=0;
	}
	
	public Multinsieme () {
		this(10);
	}
	
	
	public void add (int elem) {
		if (numElementi<a.length) {
			a[numElementi]=elem;
		} else {
			int n=a.length;
			int[] nuovo = new int[2*n];
			for (int i=0; i<n; i++) {
				nuovo[i]=a[i];
			}
			nuovo[n]=elem;
			a = nuovo; //sostituisco l'array di istanza con il nuovo array
		}
		numElementi++;
	}
	
	public int size() {
		return numElementi;
	}
	
	
	
	/*
	 *    [[1, 5, 3, 1, 0, 5, 2]]   Elimino "5"-->  [[1, 3, 1, 4, 5, 2]]
	 *    
	 *    [1, 5, 3, 1, 0, 5, 2, ?, ?, ?]   a.length=10 numElementi=7
	 *    [1, ?, 3, 1, 0, 5, 2, ?, ?, ?]   
	 *    [1, 2, 3, 1, 0, 5, ?, ?, ?, ?]   a.length=10 numElementi=6
	 *    [1, 3, 1, 0, 5, 2, ?, ?, ?, ?]   a.length=10 numElementi=6
	 *    
	 */
	
	public boolean delete (int elem) {
		int posElem=-1; // per memorizzare la posizione di elem nell'array a
		for (int i=0; i<numElementi && posElem==-1; i++) {
			if (a[i]==elem) posElem=i;
		}
		if (posElem == -1) {
			return false;
		} else {
			//sostituisco l'elemento in posizione posElem con l'ultimo elemento 
			a[posElem]=a[numElementi-1];
			numElementi--;
			return true;			
		}
	}
	
	public int occorrenze (int elem) {
		int ris=0;
		for (int i=0; i<numElementi; i++) {
			if (a[i]==elem) ris++;
		}
		return ris;
	}

}
