package es07;

public abstract class Funzione {
	
	public abstract double calcola (int x);
	
	public boolean LEq (Funzione f, int x) {
		double thisDiX = calcola(x);
		double fDiX = f.calcola(x);
		return thisDiX <= fDiX;
	}

}


class FunzionePolinomiale extends Funzione {
	private double[] a;

	public FunzionePolinomiale(double[] a) {
		this.a = a;
	}

	@Override
	public double calcola(int x) {
		double ris = 0;
		double moltiplicatore = 1;
		for (int i = 0; i < a.length; i++) {
			ris += a[i] * moltiplicatore;
			moltiplicatore = moltiplicatore * x;
		}
		return ris;
	}

}

class IperboleEquilatera extends Funzione {

	private double a;
	private double b;
	private double c;
	private double d;
	
	public IperboleEquilatera (double a, double b, double c, double d) {
		this.a=a;
		this.b=b;
		this.c=c;
		this.d=d;
	}
	
	
	@Override
	public double calcola(int x) {
		return (a*x+b)/(x*c+d);
	}
	

}