package es08;
import java.util.ArrayList;

public class Legge {
	private final String titolo;
	private final ArrayList<Articolo> articoli;
	
	public Legge(String titolo) {
		this.titolo=titolo;
		articoli = new ArrayList<>();
	}
	
	public void addArticolo (Articolo a) {
		boolean trovato=false;
		boolean superato=false;
		// inseriamo l'articolo nella posizione corretta 
		// per mantenere un ordine crescente
		int posizioneInserimento=0;
		for (int i=0; i<articoli.size() && !trovato
				  && !superato; i++) {
			int numero=articoli.get(i).getNumero();
			if (numero==a.getNumero()) {
				trovato=true;
			} else if (numero < a.getNumero()) {
				posizioneInserimento=i+1;
			} else {
				superato=true;
			}
			
		}
		if (!trovato) {
			articoli.add(posizioneInserimento,a);
		}
	}
	
	public String getTitolo() {
		return titolo;
	}
	
	public int getNArticoli() {
		return articoli.size();
	}
	
	public Articolo getArticolo (int k) {
		for (Articolo a:articoli) {
			if (a.getNumero()==k) {
				return a; 
			}
		}
		return null;
	}
	
	public String toString() {
		String s = "LEGGE - " + titolo + "\n";
		for (Articolo a:articoli) {
			s += a;
		}
		return s;
	}
}

